#define Versus  "Version 16/05/13"
#define Source " 18F46K22_test_AD9850.c"
#define Projet " 18F46K22_DDS_AD9850_joystick.mcp"

/* ============  HISTORY ======================
16/05/2013
PB init AD9850
 soluce: 
 ne pas se preoccuper de la ligne Reset => Pin5 RESET mis au Gnd !

=> test AD9850 seul 
W32-W38 = 0x20 for power down
W32-W39 = 0x00 for power up   Desired  output phase =0
W32-W39 = 0x04 for power up   Desired  output phase =45
W32-W39 = 0x02 for power up   Desired  output phase =90
W32-W39 = 0x14 for power up   Desired  output phase =60
W32-W39 = 0x1A for power up   Desired  output phase =120
W32-W39 = 0x01 for power up   Desired  output phase =180


15/05/2013
 modification pour passer au module AD9850
 voir AD9850_HC_R08_pinout_drw.jpg
 resolution : 0.0291 Hz,
 test OK a 1000,2000,20000,50000hz 
 amplitude Sinus1 AD9850 : 0.370V eff 1000 Hz
 amplitude DDS PIC : 1.318V eff a 1000 Hz
 PB mauvaise init sur RESET MAIS   Init OK si Mise sous tension !!


------ AD9850 -------------------
Mont sur une Breakboard AD9850 HC R08
---------------------------------
 
 Fquartz = 125 Mhz
 => nouveau Coeff_DDS =

/* *****************************************************************************
 Project name:      GeneBF DDS 
    directory       C:\_C18\_MesProjets_C18\_18F_DDS\
	Project : 	    18F46K22_DDS_AD9835.mcp
	main Source	:   18F46K22_test_AD9850.c
	chargeur:       1.hex
    linker:         ..\common\18f46k22_GrosseBank.lkr
    Others:         voir 18F46k22_DDS_AD9835.tmf
    option alternative compilateur C8 : 
      -k --verbose -Ou- -Ot- -Ob- -Op- -Or- -Od- -Opa- -nw=2066   -nw=2073 -pa=3

     MCU:             PIC18F46K22
     Dev.Board:       Own proto board
     Oscillator:      10.0000 MHz Crystal With PLL actived => 40Mhz
     int. Modules:    Internal DAC 5 bits with output on RA2
     Ext. Modules: 
                    LCD 2x16
                    platine DDS AD9850_HC_R08 avec Q=125Mhz
                    platine Joystick 5 pins
                    DS275 like

     Software:      MPLAB IDE  8.90.00.00 
                    MPLAB C18 rev 3.44
			        Pickit3  Config bits : 3300 3C19 9D00 0084 C00F E00F 400F 
			        Terminal VBray
			        PIC_calculs_datas_120408.xls\UART SPBRG calculator

     Export File options
                    export: Programm memory
                            configuration bits
                            EEprom memory
                            ID
                    format : INHX32 intel   
                    
     outils :       Oscilloscope HAMEG 2x60Mhz
                    Multimetre FI515X  V,F
                    terminal RS232  pour tracage et debugging si PortB bit1=0               
                    
     Hardware : HARDWARE_18F46K22_DDS_130318_ADC5b_AD9835_LCD_RS232_BP.tx              

=========== new  HARDWARE ====================

PIC 18F46K22  DIP 40   microchip  ..programme avec PICKIT3

MCLR   1  -- R=1K----|-- C=1F ------ 0V
          |          |-----R=10K --- +5V
          |------ Jaune -------------- VPP ICSP ---  pin1 Pickit3

PORTA
 RA0   2  Analog Input <---- Joystick Potar reglage 
 RA1   3  Analog Input <---- Joystick Potar deplacement Horizontal dans le menu
 RA2   4  output DAC 5 bits  ---> direct DDS 
 RA3   5  Analog Input <---- Seuil=1,65V via pont diviseur pour seuil bas compartors joystik 
 RA4   6  ---- 750 -- Led Rouge --- +5V
 RA5   7  
 
PORTE
 RE0   8  output .. Led_Down --- 750 -- +5V   (ON Decr si <400 ) 
 RE1   9  Output .. Led_Neutre   .. 750 ohms +5V ( si 401 a 599)
 RE2   10  Output .. Led_Up   --- 750 -- +5V   (ON Incr si >600)
 
 
 VDD   11 	Alim +5V
 VSS   12 	alim 0V
 			VSS---- blanc ---  Gnd  ----  pin3 Pickit3

PORTA suite 
 RA7  13 Quartz 10Mhz  C=22pF -- Gnd  x4 PLL !
 RA6  14 Quartz ---    C=22pF -- Gnd
 
PORTC
 RC0   15	input libre
 RC1   16	input libre  
  								           	D0		DDS AD9850 HC-08 Breakout   Gnd
 								           	D1		DDS AD9850 HC-08 Breakout   +5V
 								           	D2		DDS AD9850 HC-08 Breakout   +5V 
                                     Connecteur 
                                      +5V  6-----1   DDS AD9850 HC-08 Breakout
                                      Gnd  5-----6   DDS AD9850 HC-08 Breakout
 RC2   17	output ..............  Reset   2-----5   DDS AD9850 HC-08 Breakout
 RC3   18 	output SPI CLOCK.....  W_CLCK  1-----2   DDS AD9850 HC-08 Breakout
 RC4   23 	output SPI DATA ...... SDATA   3-----4   DDS AD9850 HC-08 Breakout
 RC5   24 	output ................ FU_UD  4-----3   DDS AD9850 HC-08 Breakout
 RC6   25  	TX  UART1 TTL  -- fil rouge -- 1 - like DS275 - 5 -> RS232 -- 3 HE10 -- Rx PC ecran
 RC7   26  	RX  UART1 TTL  --- fil blanc-- 3 - like DS275 - 7 <- RS232 -- 2 HE10 ---TX PC clavier
 			ou si liaison au module BT
 RC6   25  	TX  UART1 TTL  -- fil rouge ---R750--- Rx module BT
 RC7   26  	RX  UART1 TTL  ---fil blanc ---R750--- TX module BT 
 
  
PORTD                                        
 RD0   19	input 
 RD1   20   input 
 RD2   21   input 
 RD3   22   input 

 RD4   27   input 
 RD5   28   libre
 RD6   29   reserv SoftUART2 ---> TX HARDW UART2 1200,E,7,1  
 RD7   30   reserv SOFTUART2 <--- RX HARDW UART2 1200,E,7,1 
 
 VSS	31  Alim 0V Gnd
 VDD	32 Alim +5V

PortB
 RB0  33 	input ..recoit le BP du joystick  (R de 4,7 a 10k de rappel au +5V)
 RB1  34	input for debugging tests
 RB2  35	LCD RS
 RB3  36	LCD Enable
 RB4  37	LCD B3
 RB5  38	LCD B4
 RB6  39	LCD B6 & 750 --- ICSP_Clck   Bleu fonc    Pin5 Pickit3
 RB7  40	LCD B7 & 750 --- ICSP_Data   Bleu clair    Pin4 Pickit3

 
 VSS  12  ---- blanc ---  Gnd  ----  pin3 Pickit3
 VSS  12  ----  GND Power
 VSS  31  ----  GND Power
 VDD  11  ----  +5V Power
 VDD  32  ----  +5V Power

Interface 2Tr pour liaison HARDW UART TTL <-> RS232 19200 bauds


====================================================
 

#include <p18f46k22_.h>   /* for TRISB and PORTB declarations */

#include "stdio.h"
#include <stdlib.h>
#include <delays.h>
#include <string.h>
#include <usart.h>   // pour fonctions UART
#include <adc.h>
#include <ctype.h>
#include <portb.h>
#include <timers.h>
#include <math.h>

// config du PIC via MPLAB
// Configure
//      select device
//           choisir PIC18F46K22
// Configurations bits
//         si la config du PIC faite par MPLAB , enlever la coche "Configuration Bits set in code".
//         dans le cas present : coche enlev
// voir Help
//  Topics
//        Pic18
//            config bits settings

#ifdef OSCILLATEUR_INTERNE
#pragma config FOSC = INTIO67, FCMEN = OFF, PLLCFG=OFF            // CONFIG1H
#else
#pragma config FOSC = HSMP, PLLCFG=ON, PRICLKEN=ON ,FCMEN=OFF
#endif
#pragma config IESO=OFF,PWRTEN=OFF,BOREN=OFF,WDTEN=OFF,CCP2MX=PORTC1
#pragma config PBADEN=OFF,T3CMX=PORTC0,P2BMX=PORTC0
#pragma config MCLRE=EXTMCLR,STVREN=OFF,LVP=ON,XINST=OFF,DEBUG=OFF
#pragma config CP0 = OFF, CP1 = OFF, CP2 = OFF, CP3 = OFF                    // CONFIG5L
#pragma config CPB = OFF, CPD = OFF                                          // CONFIG5H
#pragma config WRT0 = OFF, WRT1 = OFF, WRT2 = OFF, WRT3 = OFF                // CONFIG6L
#pragma config WRTB = OFF, WRTC = OFF, WRTD = OFF                            // CONFIG6H
#pragma config EBTR0 = OFF, EBTR1 = OFF, EBTR2 = OFF, EBTR3 = OFF            // CONFIG7L
#pragma config EBTRB = OFF     

// config vue par Pickit3
// 3300 3C19 9D00 0084 C00F E00F 400F
// checksum F6E8
#define LCD2x16

#define Byte unsigned char
#define CLS 12
#define TAB 9
#define CR 13
#define LF 10
#define Bell 7
#define ON 0	// logique inverse avec led tiree au +5V
#define OFF 1

#define DureeCycle 20 // * 1 diziemes de secondes => 2,0sec
#define Max_Pos_Menu 7
#define SB 250      // seuil de detection joystick BAS
#define SH 750      // seuil de detection joystick HAUT 

#define SIZE	64		/* taille buffer */
#define TDRE	0x80


rom const char chaine0[]=" Frame Erreur et Overflow detection : ";
rom const char chaine1[]=" Port comm 19200bds ouvert";
rom const char chaine2[]=" Marquer 2% du signal";
rom const char chaine3[]=" ESC pour sortir\r";
rom const char chaine4[]=" Capture Taux sur ADC0 ";
rom const char chaine5[]=" Init Comparators 1 et 2 : ";
rom const char chaine6[]=" Facteur DDS AD9850 = "; 
rom const char chaine7[]=" Usage Q=10Mhz x4(PLL)\r";
rom const char chaine8[]=" Erreur Saisie.....\r";
rom const char chaine9[]=" Init ConsFreq 1Khz\t";
rom const char chaine10[]=" Facteur DDS = ";
rom const char chaine11[]=" Interface via Terminal RS232 ET/OU via Joystick + LCD\r";
rom const char chaine12[]=" Gamme de 1 a 25.000Hz  \r";
rom const char chaine13[]=" " Source "\r";
rom char *Menu_Str[]={chaine0,chaine1,chaine2,chaine3,chaine4,chaine5,chaine6,chaine7,
                        chaine8,chaine9,chaine10,chaine11,chaine12,chaine13,};
                        


#pragma romdata EEP1_=0xF00000

      rom unsigned char EEPROM_data [][32] ={
      //   1234567890123456789012345678901
          " 18F46K22 40Mhz Q=10Mhz PLLx4\r", //0 0   avec terminateur zero
          " Sinus                       \r", //1 20
          " Carre                       \r", //2 40 
          " Triangle                    \r", //3 60 
          " Dent de scie                \r", //4 80 
          " Reverse dent de scie        \r", //5 A0 
          " Rectangle f(Taux)           \r", //6 C0 
          " Reglage Taux Rectangle en % \r", //7 E0 
          " Reglage Freq DDS AD9850 a :  ",  //8 100 
          " Choix Freq.PICDDS 1 parmi 63\r", //9 120 
          " Reglage Fin Frequence PICDDS\r", //10 140
          " Reglage Freq DDS AD9850 a :  ",  //11 160
          " Init sortie DAC maxi a :     ",  //12 180  <- version 5BP only
          " MPLAB IDE V8.90,C18 V3.44.  \r", //13 1A0
          " "    Versus    "  paulfjujo \r", //14 1C0
          " 15- ------------------------\r"  //15 1E0
          };
  #pragma
  #pragma romdata EEP2_=0xF00200
          rom unsigned char EEPROM_MSG [][16]={
   // tous les msg sont cadres sur 16 cars, donc sans terminateur zero !
         //1234567890123456
         // "Version 16/03/13",//0  <- respecter ce format !!
          "0 --------------",//0    0
          "     SINUS      ",//10   1
          "     Carre      ",//20   2
          "     Triangle   ",//30   3
          " Dents de SCIE  ",//40   4
          "rev Dent de SCIE",//50   5
          "    Rectangle   ",//60   6
          "Mode DDS AD9835 ",//70   7
          "Regl.TAUX Rectan",//80
          "Choix Freq Fixes",//90   9
          "Regl.Freq PICDDS",//A0   10
          "Regl.Freq AD9850",//B0   11
          "F0 ou F1  AD9850",//C0   12
          "13 -------------",//D0   13
          Versus,            //E0   14  "Version JJ/MM/AA"
          "15--------------" //F0   15
          
          };      
#pragma


#ifndef  LCD_DATAPORT 
// DATA_PORT defines the port to which the LCD data lines are connected 
#define LCD_DATAPORT       PORTB
#define LCD_DATAPORT_TRIS  TRISB        //4 upper bits only
//CTRL_PORT defines the port where the control lines are connected.
//ReadWrite Pin
#define LCD_RWPIN       PORTBbits.RB1       // not used
#define LCD_RWPIN_TRIS  TRISBbits.TRISB1    // not Used  RW connected to Gnd
//RS Pin
#define LCD_RSPIN       PORTBbits.RB2
#define LCD_RSPIN_TRIS  TRISBbits.TRISB2
//Enable Pin
#define LCD_ENPIN       PORTBbits.RB3
#define LCD_ENPIN_TRIS  TRISBbits.TRISB3
#endif


#define Led_Up       LATEbits.LATE2
#define Led_Centre   LATEbits.LATE1
#define Led_Down     LATEbits.LATE0
#define Led_Rouge  LATAbits.LATA4

// DDS part .....
#define FU_UD LATCbits.LATC5          // RC5 pin 24 ... 3 DDS board
#define W_CLCK  LATCbits.LATC3         // RC3 pin 18 ....2 DDS Board 
#define SDATA LATCbits.LATC4          // RC4 pin 23 ... 4 DDS Board 
#define Pin_Reset_AD9850 LATCbits.LATC2   // RC2 pin 17 ... 5 DDS board
#define QUARTZ_DDS 1250000000.0     //MHZ  quartz de la platine DDS
//#define Const_Freq_AD9835  85.89934592    // = 2^32/Quartz_DDS(50Mhz)
#define Const_Freq_AD9850 34.359738     // = 2^32/Quartz_DDS(125Mhz)
#define Butee_Mini_AD9850  34           // pour 1Hz   0x22
#define Butee_Maxi_AD9850  1374389535L   // pour 40Mhz 0x51EB851E
 
//A good rule-of-thumb for applying the AD9850 as a clock
//generator is to limit the selected output frequency to <33% of
//Reference Clock frequency,   125/3=>40Mhz


//#define  LCD_L1home    LCD_Cde(0x80)
//#define  LCD_L2home    LCD_Cde(0xC0)
//#define  LCD_Clear     LCD_Cde(0x01)
//#define  LCD_ReturnHome LCD_Cde(0x02)

#pragma udata GrossBank
static unsigned char buffer[128];
unsigned int Table_Freq [64]={
1,2,5,10,20,50,100,200,500,750,
1000,1250,1500,1750,2000,2500,2750,3000,3500,4000,
4500,5000,5500,6000,6500,7000,7500,8000,8500,9000,
9500,10000,11000,12000,13000,14000,15000,16000,17000,18000,
19000,20000,21000,22000,23000,24000,25000,26000,27000,28000,
29000,30000,31000,32000,33000,34000,35000,36000,37000,38000,
39000,40000,42500,45000
};

unsigned int Table_Progr_Taux[11]={
    0,1,2,10,25,50,100,250,500,750,1000};
unsigned int Table_Progr_Freq_Pic[11]={
    0,1,2,5,10,50,100,250,500,1000,5000};
unsigned long Table_Progr_Freq_AD[11]={
    0,1,5,10,50,100,500,1000,5000,10000,100000};    


#pragma udata

/*	Variables globales */
unsigned char  SIGNAL[256];
//char *Ptr_Signal=&SINE_TABLE[0];       // pointeur sur table ROM
char Texte[80]="Projet C18 :" Projet "\r";
char *txt=&Texte[0];
unsigned char Entree[16]="123456789012345";
unsigned char *valtxt;
char *ptlec;		/* pointeur de lecture */
char *ptecr;		/* pointeur d'criture */
Byte Drapeau;
Byte receive;
char error;
char EtatCf;
signed char Ve;

unsigned int dummy;
volatile int CptFO,CptFE;           // compteur erreur UART
volatile unsigned char c;
unsigned int i,j,k;
unsigned int jt;
//int Scaling_DAC;
unsigned char s_count = 0;
unsigned int Mf,Mt;
int ChoixF;
volatile unsigned int Taux;
unsigned int kk;
signed long ConsFreq=0L;
unsigned long Cons_DDS=0L ;
long FDDS[16];
float FConsDDS;
float FConsFreq;
float FFacteur_PIC;

float Tx;
float F1,F2,F3;
float FFacteur_AD9850;
float Freq_AD9850;
int SensAction;
int Step;
long Cp;
int DX;
int NbCarRef;

volatile int Pos_Menu_H,Forme;
volatile int CMP1,CMP2;
unsigned int MV,MH;
unsigned int Nt;
volatile signed long Nf;

unsigned long M1,M2;
unsigned long ML=0L ;

struct ForByte
{
	near Byte pv0;
	near Byte pv1;
	near Byte pv2;
	near Byte pv3;
	} pV,ACCU,AD,DDS;

union {
    near unsigned long ACCUMULATEUR;
	near struct ForByte ACCU;
	}U1;
	
unsigned char Ad9850_Control;

union
{
  near unsigned long Cons_DDS;
  near struct ForByte pV;
}MD;	

union {
    near 
    near unsigned long ML;
	near struct ForByte DDS;
	}U2;

volatile struct chbits {   // 8 flags
                 unsigned FrameErr:1;
                 unsigned Over:1;
                 unsigned Elligible:1;
                 unsigned poubelle:1;
                 unsigned Blc:1;
                 unsigned Change:1;
                 unsigned Fill:1;
                 unsigned Lcd:1;
               }Drapeaux ;

volatile  union
{  unsigned char Fanion;
   struct chbits Drapeaux ;
} Flags;


#define OUT_RS232 Drapeaux.Lcd=0;
#define OUT_LCD Drapeaux.Lcd=1;
#define Debugging PORTBbits.RB1
#define BP_Joystick PORTBbits.RB0    //BP valid via Pooling RB0  

volatile unsigned int count;
volatile unsigned int TimeEcoule;
volatile unsigned int OneSecond;
volatile unsigned int  Flag_IT_RB0;
unsigned int CptCars;
unsigned int SaisieOk;
unsigned int ESC;
unsigned char FREQ_E,FREQ_H,FREQ_M,FREQ_L;
//unsigned ACC_E,ACC_H,ACC_M,ACC_L;


//---- declaration des sub ----------------
void LCD_Init(void);                            //to initialise the LCD
void LCD_Put(char data);                        //to put dtat to be displayed
void LCD_PutRamString(char *string);            //to display data string in RAM
void LCD_PutRomString(rom char *string);        //to display data stringin ROM
//char LCDIsBusy(void);                         //to check Busy flag
void LCD_Cde(unsigned char cmd);                //to send commands to LCD
//unsigned char LCDGetAddr(void);
//char LCDGet(void);
void Pulse_E (void);
void LCD_Pos(char L,char posX);
void LCD_Erase_Ligne(char L1);
void LCD_Delay15ms(void);
void LCD_Delay4ms(void);
void LCD_Delay100us(void);
void LCD_Delay500ns(void);
void LCD_Delay(void);
void SetCGRamAddr(unsigned char CGaddr);


//---- EEPROM PIC de 1024 bytes !!!
unsigned char EEPROM_Lect(unsigned int AdrL) ;
void EEPROM_Ecr(unsigned int AdrE,unsigned char car);
void Save_Msg_To_EEPROM(unsigned int * adrx, unsigned char * ptr1);
void PrintOut_Eeprom_Msg(unsigned int PtrE);


////--- local Softw RS232 ------
void Init_UART1(void);
void Put_RS(unsigned char c);
int PutStr_RS(char *s);
int PutStr_RS(char *s);
unsigned char Get_RS(void);
char *GetStr_RS(char *s, char finst);
void Raz_Receipt(void);

//---- Other subroutines
void Init_Hardware(void) ;
void Tempo(long int value);
void Idle(void);
void Octet2Hex(unsigned char number);
void Decompile_byte(Byte un);
void Write_Word(unsigned int M,char Sign);
void print_flt(float W,int NbDeci,char Bold);
void fltToa (float x, unsigned char *str,char precision);
void CRLF(void);
void copyRom2Ram(unsigned char *Ramptr,rom unsigned char *Romptr);
void ReverseCopyRom2Ram(unsigned char *Ramptr,rom unsigned char *Romptr);

//----- ADC 10 bit ------
void Init_ADC(void);
//void OpenADC( unsigned char config,unsigned char config2 );
void SetChanADC( unsigned char channel );
char BusyADC( void );		// 1= busy
void ConvertADC( void );
int ReadADC( void );
unsigned int Mesure_ADC(int j) ; // utilise buffer pointe par txt
void CloseADC( void );

//--- interrupts
void Traite_ISR(void);

//- choix menu et formes --
void Choix_Sinus(void) ;                   
void Choix_Carre(void) ;    
void Choix_Triangle(void);
void Choix_Dent_de_Scie(void);
void Choix_Reverse_Dent_de_Scie(void);  
void Choix_Rectangle(void);  
void  Calcule_et_Charge_consigne_DDS (signed long CF); 
void  Update_Forme_En_Cours(void);


void Init_Timer1(void);
void Init_Comparators(void);
void Config_DAC(void);
int Time_Elapsed(void);

//-- AD9850 -- SPI  serial write data
void AD9850_write_byte_control(unsigned char Bc);  
void Serialise_Byte(unsigned char x);
void AD9850_Charge_Freq(float F);
void Init_AD9850(void);
void Reset_AD9850 (void);
//void  Reglage_Freq_AD9850(void);

void Print_Decompose_32bits (unsigned long ML);

void Traite_Menu(void);
void Reglage_Taux_Rectangle(void);
unsigned int Traite_Joystick_Taux (unsigned int Vi,unsigned int VMi,unsigned int VMa);
void Reglage_Fin_Frequence(void);
void Choix_1_Freq_parmi_64 (void);
signed long Traite_Joystick_Freq (signed long Vin,signed long VMin,signed long VMax);
void  Refresh_Affichage_Consigne_Freq(void);
void Refresh_Affichage_Consigne_Taux(void);


// ---- init  interruptions ------------------------
// Serial Interrupt
#pragma code highvector=0x0008
void interrupt_at_high_vector(void)
{
_asm   goto Traite_ISR   _endasm
}
#pragma code

#pragma interrupt Traite_ISR
void Traite_ISR(void)	// reception d'une interruption
{
    //char c;
//==== UART interrupt ===========
if ( (PIE1bits.RC1IE == 1) &&(PIR1bits.RC1IF==1)) // si IT Rx UART
{
    c =Read1USART(); // le lire => RAZ  RCIF
   
     if(RCSTA1bits.FERR==1 )
   {
     RCSTA1bits.SPEN = 0 ;
     Flags.Drapeaux.FrameErr=1;
     CptFE++;
     RCSTA1bits.SPEN= 1 ;
     }
     else
     Flags.Drapeaux.FrameErr=0;

   if (RCSTA1bits.OERR==1)    // voir parag 16.1.26 p273
   {
       RCSTA1bits.CREN = 0 ;
       Flags.Drapeaux.Over=1;
       RCSTA1bits.CREN = 1 ;
       CptFO++;
       }
      else
      Flags.Drapeaux.Over=0;

   while( Busy1USART()) ; // par scurite
   //if (PORTBbits.RB1==0) Write1USART(c); // echo
	*ptecr++ = c;
	if (ptecr >= &buffer[SIZE]) ptecr = buffer;
	}
	
// =====  Timer1 interrupt ====
 if  (( PIE1bits.TMR1IE==1)&& (PIR1bits.TMR1IF==1))
 {
      count ++;
       if (count >= DureeCycle)  // x 0.1S=> XXsec
        {
         count=0;
         Flags.Drapeaux.Elligible=1;
        OneSecond ++;
       Led_Rouge=!Led_Rouge;
        }
      WriteTimer1(3035);    // 62500*8*0.2 => 200000S  =0,1sec
      PIR1bits.TMR1IF = 0;
  }
  
    
  
 //== Interrupts via comparators ============
 if   ((PIE2bits.C1IE==1)&&(PIR2bits.C1IF==1))
 {
    if(CM2CON1bits.MC1OUT==1) CMP1=1; 
    PIE2bits.C1IE=0;
    PIR2bits.C1IF=0;
    c=27;
   // Put_RS('D');Put_RS(10);Put_RS(13);
   // Traite_Menu();
     
  }


  if ((PIE2bits.C2IE==1)&&(PIR2bits.C2IF==1))
 {
    if(CM2CON1bits.MC2OUT==1) CMP2=1; 
    PIE2bits.C2IE=0;
    PIR2bits.C2IF=0;
    c=27;
    //Put_RS('G');Put_RS(10);Put_RS(13);
    //Traite_Menu();
  }
 
}



//--------- RS232 local software --------------

void Init_UART1(void)
{
// USART_BRGH_HIGH,32
// init 38400Bd a 20Mhz
// init 19200Bd a 10Mhz avec IT en rx
// voir para 18.5 spec sheet DS41159B page 186
// 19200  64  @ 20MHz
// 38400  32  @ 20MHz
// 38400  64  @ 40Mhz  (Q=10Mhz x PLL=4)
// 115200  21 @ 40Mhz

Open1USART( USART_TX_INT_OFF &
USART_RX_INT_ON &
USART_ASYNCH_MODE &
USART_EIGHT_BIT &
//USART_CONT_RX &
USART_SINGLE_RX &
//USART_BRGH_HIGH,64      //38400 bds
USART_BRGH_HIGH,128      //19200 bds
);
IPR1bits.RC1IP=1;  // high priority for UART
RCONbits.IPEN = 1;     // Enable High interrupt priority model.
PIE1bits.RC1IE = 0;
INTCONbits.PEIE = 0 ; // autorisation des IT des priphriques
INTCONbits.GIE = 0 ; // autorisation globale des IT
}

int PutStrR_RS(rom char *s)
{
	int n;
	for (n = 0; *s; n++, s++)
	{
       	Put_RS(*s);
     	}
	return n;
}


int PutStr_RS(char *s)
{
	int n;
	for (n = 0; *s; n++, s++)
	{
       	Put_RS(*s);
     	}
	return n;
}

void Put_RS(unsigned char untel)
{
   	while(Busy1USART());
   	//putc1USART(untel);
   	Write1USART(untel);
}

void CRLF()
{
  Put_RS(CR);  Put_RS(LF);
  }

unsigned char Get_RS(void)
	{
	unsigned char c;
	while (ptlec == ptecr);
	c = *ptlec++;
	if (ptlec >= &buffer[SIZE])	ptlec = buffer;
	return (c);
}


void Raz_Receipt()
{ptecr=buffer;
      ptlec= ptecr;
      CptCars=0;
      c=0;
      receive=0;
 }   
 
 
 //------  EEPROM  PIC 18FX6K22  1024 bytes !!------------

unsigned char EEPROM_Lect(unsigned int AdrL) 
{ 
    EEADR =(unsigned char)(AdrL&0x00FF);
    EEADRH =(unsigned char) ((AdrL>>8)& 0x03);   //Bits 3-7 are masked off since EEPROM is only 1KB
//	EEADR=(Hi)AdrL;
//	EEADR=(low)AdrL;
	EECON1bits.EEPGD=0;     // 0= adressage EEPROM
	EECON1bits.CFGS=0;      // 0= acces data EEPROM
	EECON1bits.RD=1;        // arme Lecture EEprom
	 Tempo(1000L);
	return(EEDATA);
}

void EEPROM_Ecr(unsigned int AdrE,unsigned char car) // ecrit  a l'adresse adrE
{int dr;
    
    if (Drapeaux.Lcd) AdrE=AdrE + 0x02;
    EEADRH = ((AdrE>>8)&0x03);   //Bits 2-7 are masked off since EEPROM is only 1KB
    EEADR =(AdrE &0xFF);
	EEDATA=car;
	EECON1bits.EEPGD=0;
	EECON1bits.WREN=1;            // autorise ecriture EEPROM
	EECON1bits.CFGS =0;
  if(INTCONbits.GIE ==1)
    {
    INTCONbits.GIE =0 ;
    dr=1;
    }
	EECON2=0x55;
	EECON2=0xAA;
	EECON1bits.WR=1;
	while (PIR2bits.EEIF==0);
	PIR2bits.EEIF=0;
	EECON1bits.WREN=0;
	if (dr==1)INTCONbits.GIE =1;
}

void Save_Msg_To_EEPROM(unsigned int * adrx, unsigned char * ptr1)
{
	while (*ptr1) EEPROM_Ecr(adrx++,*ptr1++);
}

void PrintOut_Eeprom_Msg(unsigned int PtrE)
{ // imprime  N de msg en eeprom until carcatere=0 ou 15 cars maxi si choix LCD
  int i,j;
  // calcule adresse offset du msg 
    if (Drapeaux.Lcd==1) 
    {
       // Put_RS(('1');
        PtrE=(PtrE<<4)+0x0200;
         }
        else 
        {
           // Put_RS(('0');
            PtrE=PtrE<<5;
            }
    // Numero de msg *16 car pour LCD
    // numero Msg *32 car pour ecran RS232
  j=0;
  do
  {
  if ( PtrE >1023) break;
  i = (int)EEPROM_Lect(PtrE);
  if ( i==0) break;
  if ((Drapeaux.Lcd==1) && (j>15)) break;  // msg cadres sur 16 bytes !!
  //if(Drapeaux.Lcd==0)
   Put_RS((Byte)i);
  // else LCD_Put((Byte)i);
  PtrE++;j++;
  }
  while (i!=0)  ;
 Tempo(1000L);
}



void Write_Word(unsigned int M,char Sign)
{
unsigned int i,k,l;
unsigned long M1;
 valtxt=&Entree[0];
 if (Sign>1) return;
 if (Sign==0)
  {       M1=(long)M;
        ultoa(M1,valtxt);
  }
  else itoa(M,valtxt);
 if (Flags.Drapeaux.Fill==1)
 {
  k=strlen(valtxt);
  for (i=0;i<k;i++) Entree[4+Sign-i]=Entree[k-i-1];
  for (i=0;i<(5+Sign-k);i++)
  {if (Flags.Drapeaux.Blc==1) Entree[i]='0'; else Entree[i]=' ';}
 }
 Entree[5+Sign]=0;
// if (Drapeaux.Lcd)
//  LCD_PutRamString(valtxt);
//   else
 k=PutStr_RS(valtxt);
}

void fltToa (float x, unsigned char *str,char precision)
{
/* converts a floating point number to an ascii string */
/* x is stored into str, which should be at least 30 chars long */
unsigned char *adpt;
int ie, i, k, ndig;
double y;
adpt=str;
ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
ie = 0;
/* if x negative, write minus and reverse */
if ( x < 0)
  {
  *str++ = '-';
  x = -x;
  }
/* put x in range 1 <= x < 10 */
if (x > 0.0) while (x < 1.0)
  {
  x *= 10.0;		// a la place de =*
  ie--;
  }
while (x >= 10.0)
  {
  x = x/10.0;
  ie++;
 }
 ndig += ie;				// a la place de =+
//round. x is between 1 and 10 and ndig will be printed to
// right of decimal point so rounding is ...
for (y = i = 1; i < ndig; i++)
  y = y/10.;
x += y/2.;
if (x >= 10.0) {x = 1.0; ie++;}
if (ie<0)
  {
   *str++ = '0'; *str++ = '.';
   if (ndig < 0) ie = ie-ndig;
   for (i = -1; i > ie; i--)  *str++ = '0';
  }
for (i=0; i < ndig; i++)
  {
  k = x;
  *str++ = k + '0';
  if (i ==  ie ) *str++ = '.';
  x -= (y=k);
  x *= 10.0;
  }
*str = '\0';
//return (adpt);
}


void print_flt(float W,int NbDeci,char Bold) // avec NbDeci=1,100,1000,10000
{long lWhole;
 unsigned int ulPart;
 Drapeaux.Fill=0;
 lWhole=(long)(W);
 ulPart=(unsigned int)( (float) NbDeci*(W - (float) lWhole));
 ultoa(lWhole,&Texte[0]);
 //if (Drapeaux.Lcd==1) LCD_PutRamString(Texte);else
  k=PutStr_RS(Texte);
 //if (Drapeaux.Lcd==1) LCD_Put('.'); else 
  Put_RS('.');
 Write_Word(ulPart,0);
}

void Decompile_byte(Byte un) {
Byte masque;
  masque = 0x80;
  while (masque > 0u )
 {
  if (un & masque)
      Put_RS(49u);  //  '1'
    else
      Put_RS(48u);  //  '0'

    masque =masque >>1;
     }
}

void Octet2Hex(unsigned char number)
{
char high,low;
  low=0;
  // high nibble
  high = ((number & 0xF0) >> 4) + 48; // + '0'
  if (high > '9')    high =high + 7;
 // low nibble
  low = (number & 0x0F) + 48;          // +'0' low nibble
  if (low > '9')  low += 7;                        // '9'= 57u
 // if(Drapeaux.Lcd==0)
 //  {
    Put_RS(high);   
    Put_RS(low);
    Put_RS('h'); 
//   }
//   else
 //  {
 //   LCD_Put(high);  
 //   LCD_Put(low); 
 //   LCD_Put('h');
 //   } 
}

void Tempo(long val)
{
while(val>0){val--;}
}

void Remplis_N_blancs(Byte N)
{int i;
 for (i=0;i<N;i++)  Put_RS(' ');
}



void Init_Hardware()
{  
  PORTA = 0X00;
  ANSELA=0;
  ANSELAbits.ANSA0=1;    //  analog input on RA0   voir page 154
  ANSELAbits.ANSA1=1;    //  analog input on RA1 
  ANSELAbits.ANSA2=1;    //  analog input on RA2 
  ANSELAbits.ANSA3=1;   //  analog input on RA3
  TRISA = 0b00001111 ;   // PORTA is RA0,1= analog input  RA2=sortie DAC5b,  RA3,4,5=Digital output
   
  PORTB = 0xFF;
  ANSELB=0;
  TRISB = 0x03;    // RB0,RB1 as input, others as ouput  ATTENTION B7 B6 for ICSP Pickit3
  WPUB=0x02;               // any pin pull up
  INTCON2bits.RBPU=0;  
 
  PORTC = 0x00;          
  ANSELC=0;
  TRISC = 0b10000000;    // RC0..RC6=Output 
  //TRISCbits.TRISC6 = 0;  // TX - UART1
  TRISCbits.TRISC7 = 1;  // RX - UART1
  PORTC=0;

 //only for 18F46K22 
  PORTD=0x00;
  ANSELD=0 ;   // No Analog
  TRISD=0b10111111;  //0xBF  all input  except D6as output for TX UART2
  
  PORTE=0;
  ANSELE=0;
  TRISE=0x00;  // all outputs

  SLRCON=0; // standard rate for PORTA,B,C,D,E
  

 }


//=========== DDS AD9850 ============

void Reset_AD9850 ()
{
    
Pin_Reset_AD9850=1;
Delay10TCYx(10);
Pin_Reset_AD9850=0;
Delay10TCYx(10);
 
    
FU_UD = 0;
W_CLCK = 0;
SDATA=0;

 // init AD9850
SDATA=0; 
W_CLCK = 0;
FU_UD = 0;
Delay10TCY();

FU_UD = 1;          // reset adresse to W0
//Delay10TCYx(10);
//Delay10TCY();
FU_UD = 0;   

W_CLCK = 1;         //1ere 
Delay10TCY();
W_CLCK = 0;
Delay10TCY();

FU_UD = 1;          // Enable serial mode
Delay10TCY();
FU_UD = 0;  
Delay10TCY();


}


void Init_AD9850()
{
Byte nbit;
FU_UD = 0;
W_CLCK = 0;
SDATA=0;

 // init AD9850
SDATA=0; 
W_CLCK = 0;
FU_UD = 0;
Delay10TCY();

FU_UD = 1;          // reset adresse to W0
//Delay10TCYx(10);
//Delay10TCY();
FU_UD = 0;   

W_CLCK = 1;         //1ere 
Delay10TCY();
W_CLCK = 0;
Delay10TCY();

FU_UD = 1;          // Enable serial mode
Delay10TCY();
FU_UD = 0;  
Delay10TCY();

// RAZ W32,W33,W34   see page 12/20
nbit= 3;
do 
 {
    SDATA = 0;
    W_CLCK = 1;
    Delay10TCY();
    W_CLCK= 0;
     Delay10TCY();
    nbit--;
} while (nbit>0);

Delay10TCY();
FU_UD = 0;
Delay10TCY();
FU_UD = 1;  // Reset control word 
Delay10TCY();
FU_UD = 0;
Delay10TCY();
}


void AD9850_Charge_Freq(float F)
{
 U2.ML= (long) (F * FFacteur_AD9850); 
 Serialise_Byte(U2.DDS.pv0);
  Serialise_Byte(U2.DDS.pv1);
   Serialise_Byte(U2.DDS.pv2);
    Serialise_Byte(U2.DDS.pv3);
   Serialise_Byte( Ad9850_Control) ; 
    Delay10TCY();
     // terminaison
    FU_UD = 1; Delay10TCY();
    FU_UD = 0;  
}

     
void Serialise_Byte(unsigned char x)
{
// LSB first !!!
 Byte nb;
 nb= 8;
 do {
    SDATA = 0;
    if (x & 1)SDATA = 1; // check LSB bit
    x = x>>1;
    W_CLCK = 1;
    Delay10TCY();
    W_CLCK= 0;
    nb--;
   } while (nb>0);

}


 

//**************************
//           MAIN
//**************************
 void main()
 {
 PORTC=0;    
 Init_Hardware() ;
 Reset_AD9850 ();
 Tempo(150000L);
 Led_Rouge=0;    //allume
 OneSecond=0;
 count=0;

  // init des pointeurs stockage reception car
 ptecr=buffer;
 ptlec= ptecr;
 txt=&Texte[0];
 // init accumulateur DDS
 U2.ML=0;  // 1Hz
 
  Flags.Fanion=0;           // <- init globale des flags a Zero
  Flags.Drapeaux.Fill=1;    // <- init individuelle des flags
  Flags.Drapeaux.Blc=1;
  Flags.Drapeaux.Elligible=0; // inutile mais pour la comprehension
  Flags.Drapeaux.Change=0;
  Flags.Drapeaux.FrameErr=0;
  Flags.Drapeaux.Over=0;

  CptFE=0;
  CptFO=0;
   ESC=0;

 OUT_RS232
 Init_UART1();	//19200 bauds
 Put_RS(CLS);
 Tempo(200000L);  // laisser un peu de temp pour l'effacement ecran Terminal VBray
 CRLF();
 
//**********  test : //Test_Joystick_Vertical_f_duree.txt *******


 strcpypgm2ram(&Texte[0],Menu_Str[1]);  // port com ouvert
 k=PutStr_RS(Texte); CRLF(); 
 strcpypgm2ram(&Texte[0],Menu_Str[13]);  // source fichier C
 k=PutStr_RS(Texte); CRLF();
 strcpypgm2ram(&Texte[0],Menu_Str[11]);  // Interface..
 k=PutStr_RS(Texte);
 strcpypgm2ram(&Texte[0],Menu_Str[12]); // gamme...
 k=PutStr_RS(Texte);

 PrintOut_Eeprom_Msg(0);      // 18F46k22...
 PrintOut_Eeprom_Msg(13);     // version MPLAB
 PrintOut_Eeprom_Msg(14);     // version du programme
 CRLF();

Led_Rouge=0;

do
{
 //---------   Partie init AD9850  ---------------------
 FFacteur_AD9850=Const_Freq_AD9850;
 strcpypgm2ram(&Texte[0],Menu_Str[6]); // coeff DDS AD9850
 k=PutStr_RS(Texte);
 fltToa (FFacteur_AD9850,txt,8);
 k=PutStr_RS(txt);
 CRLF();
 Ad9850_Control=0;


// NOTE: FOR DEVICE START-UP IN SERIAL MODE, 
//HARD-WIRE LEAD 2 AT 0," LEAD 3 AT 1," AND LEAD 4 AT 1
 Init_AD9850();
 Tempo(1000000L);

 PrintOut_Eeprom_Msg(8);  // reglage freq AD9850
 // valeur par defaut idem que DDS PIC18
 Freq_AD9850=2000.0;
 AD9850_Charge_Freq(Freq_AD9850);
 fltToa (Freq_AD9850,txt,1);
 k=PutStr_RS(txt);
 CRLF();
 Tempo(1000000L);
  
  Freq_AD9850=10000000.0;   // 10Mhz
 AD9850_Charge_Freq(Freq_AD9850);
 fltToa (Freq_AD9850,txt,1);
 k=PutStr_RS(txt);
 CRLF();
  Tempo(1000000L);

Freq_AD9850=1000.0;   // 2khz
j=0;
do
{
   
 AD9850_Charge_Freq(Freq_AD9850);
 fltToa (Freq_AD9850,txt,1);
 k=PutStr_RS(txt);
 CRLF();


/* RESULTS OF RESET:
 FREQUENCY/PHASE REGISTER SET TO 0
 ADDRESS POINTER RESET TO W0
 POWER-DOWN BIT RESET TO 0
 DATA INPUT REGISTER UNEFFECTED

W34 = Power down bit of Control byte (4em byte))

docu AD9851 : page 13
FQ_UD pulse is sent after initial pow er-up and RE SET of the 
AD9851. Since RESET does not clear the 40-bit input register, 
this will transfer the random power-up values of the input register 
to the DDS core. The random values may invoke the factory test 
mode or power-down mode. Never issue an FQ_UD command if 
the 40-bit input register contents are unknown.

*/
Led_Rouge=0;  
Pin_Reset_AD9850=1;
Delay10TCYx(10);
Pin_Reset_AD9850=0;
Delay10TCYx(10);
Tempo(400000L);   // delai to see when reset occured
//Oscilloscope is connected to Sinus output !
Led_Rouge=1;
Freq_AD9850=Freq_AD9850+10.0;
 }
 while (j<10)  ;
}
while (1)  ;
}

//-------------------   end of  Main --------------------
